from accpac import *

# onOpen is called when the view is opened.
# Return Continue to enable the macro.
# Return 0 to disable the macro.
# If you return anything else then the view will not load.
def onOpen():
	if rotoID != "PO0700":
		return 0 # don't do anything since the view is not ELVEND.
	return Continue

def onBeforePut(e):
	rvspyTrace("onBeforePut [" + str(e.value) + "] to [" + e.field + "]")

	if (e.field == "INVNUMBER"):
		# Validate the INVNUMBER.
		return ValidatePrimaryInvoice(e.value)


	return Continue

def ValidatePrimaryInvoice(v):
	# Take the field value and check if it exists already.
	errFlag = Continue

	# First test - check invoice doesn't already exist in Purchase Orders for this vendor.

	sFilter = "INVNUMBER=\"" + str(v) + "\" AND VDCODE=\"" + str(me.get("VDCODE")) + "\""
	#showMessage(sFilter)

	poinvh = openView("PO0420")
	poinvh.recordClear()
	poinvh.order(6)
	poinvh.browse(sFilter, 1)
	res = poinvh.fetch()
	if (res == 0):
		#--- PO Invoice already exists for this vendor. Report error.
		showMessage("Invalid Entry. PO Invoice Number " + str(v) + " already exists in Purchase Orders. Number cannot be used again.")
		poinvh.close()
		return 1

	poinvh.close()

	# Otherwise continue to the next test.

	# Second test - check the invoice doesn't exist in an open A/P invoice batch.
	sFilter = "IDVEND=\"" + str(me.get("VDCODE")) + "\" AND IDINVC=\"" + str(v) + "\" AND TEXTTRX=1"
	#showMessage(sFilter)

	apibh = openView("AP0021")	# AP Invoice Batch.
	apibh.recordClear()
	apibh.order(1)
	apibh.browse(sFilter, 1)
	res = apibh.fetch()
	if (res == 0):
		# check if the batch is open at the moment.
		apibc = openView("AP0020")
		sFilter = "CNTBTCH=" + ReplaceFields(apibh, "{CNTBTCH}")
		#showMessage(sFilter)

		apibc.recordClear()
		apibc.browse(sFilter, 1)
		res = apibc.fetch()
		if (res == 0):
			batchStatus = ReplaceFields(apibc, "{BTCHSTTS}")
			if (batchStatus == "1") or (batchStatus == "7"):
				# open batch.
				showMessage("Invalid Entry. PO Invoice Number " + str(v) + " found in open batch " + ReplaceFields(apibc, "{CNTBTCH}"))
				errFlag = 1

			if (batchStatus == "7"):
				# ready-to-post batch.
				showMessage("Invalid Entry. PO Invoice Number " + str(v) + " found in ready-to-post batch " + ReplaceFields(apibc, "{CNTBTCH}"))
				errFlag = 1

		apibc.close()

	apibh.close()

	if (errFlag == 1):
		return errFlag

	# Otherwise continue to the third test.

	# Third Test - check the invoice is in APOBL.
	sFilter = "IDVEND=\"" + str(me.get("VDCODE")) + "\" AND IDINVC=\"" + str(v) + "\" AND TXTTRXTYPE=1"
#	showMessage(sFilter)

	apobl = openView("AP0025", 1)
	apobl.recordClear()
	apobl.browse(sFilter, 1)
	res = apobl.fetch()
	if (res == 0):
		# invoice found in APOBL for this vendor.
		showMessage("Invalid Entry. PO Invoice Number " + str(v) + " found in A/P Posted documents.")
		errFlag = 1

	apobl.close()

	return errFlag
